/*
	Copyright 2009 Jerry Ylilammi
*/

#pragma once

#include "Max.h"
#include "istdplug.h"
#include "iparamb2.h"
#include "iparamm2.h"

#include "particle.h"
#include "Simpobj.h"
#include "splshape.h"

#include "meshadj.h"
#include "XTCObject.h"

#include "IParticleObjectExt.h"

#include "maxobject.h"

/*
	Extracts the point cloud (position and speed) from max
*/
class readPointCloud {
private:
	Tab<VR::Vector> posTab; // Position
	Tab<VR::Vector> velTab; // Velocity
	Tab<float> radTab; // Radius
	Tab<float> chaTab; // Change of radius	
	bool useRadii;	
	float zero;
	 
	bool readTriMesh(INode *node, TimeValue time[2]);
	bool readTriMesh(INode *node, TimeValue time);
	
	bool readSimpleParticle(INode *node, TimeValue time[2]);
	bool readSimpleParticle(INode *node, TimeValue time);
	
	bool readExtParticle(INode *node, IParamBlock2 *pblock, TimeValue time[2]);	
	bool readExtParticle(INode *node, IParamBlock2 *pblock, TimeValue time);	
public:
	float defaultRadius; // Used by meshes when "Use radii" is on because vertices don't have radius

	readPointCloud() {zero = 0.f;}
	~readPointCloud() {}
	void read(bool useRadii, int &pointCount, VR::Vector* &position, VR::Vector* &velocity, VR::Ireal* &radii, VR::Ireal* &radiiChange, IParamBlock2 *pblock, TimeValue time[2]);
	void read(bool useRadii, int &pointCount, VR::Vector* &position, VR::Ireal* &radii, IParamBlock2 *pblock, TimeValue time);
};

class Particle {
public:
	int id;
	VR::Vector position;	
	float radius;	
};